Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3876)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3883)
@@ -3060,5 +3115,5 @@
           CALL pmci_child_datatrans( child_to_parent )
 
-       ELSEIF( nesting_datatransfer_mode == 'overlap')  THEN
+       ELSEIF ( nesting_datatransfer_mode == 'overlap')  THEN
 
           CALL pmci_parent_datatrans( parent_to_child )
@@ -3068,5 +3123,5 @@
           CALL pmci_parent_datatrans( child_to_parent )
 
-       ELSEIF( TRIM( nesting_datatransfer_mode ) == 'mixed' )  THEN
+       ELSEIF ( TRIM( nesting_datatransfer_mode ) == 'mixed' )  THEN
 
           CALL pmci_parent_datatrans( parent_to_child )
@@ -3088,12 +3143,12 @@
     IMPLICIT NONE
 
-    INTEGER(iwp), INTENT(IN) ::  direction   !<
+    INTEGER(iwp), INTENT(IN) ::  direction   !<  Direction of the data transfer: 'parent_to_child' or 'child_to_parent'
 
 #if defined( __parallel )
-    INTEGER(iwp) ::  child_id    !<
-    INTEGER(iwp) ::  i           !<
-    INTEGER(iwp) ::  j           !<
-    INTEGER(iwp) ::  k           !<
-    INTEGER(iwp) ::  m           !<
+    INTEGER(iwp) ::  child_id    !<  Child id of the child number m
+    INTEGER(iwp) ::  i           !<  Parent-grid index in x-direction
+    INTEGER(iwp) ::  j           !<  Parent-grid index in y-direction
+    INTEGER(iwp) ::  k           !<  Parent-grid index in z-direction
+    INTEGER(iwp) ::  m           !<  Loop index over all children of the current parent 
 
 
@@ -3124,10 +3179,7 @@
                 DO   j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      u(k,j,i)  = MERGE( u(k,j,i), 0.0_wp,                     &
-                                         BTEST( wall_flags_0(k,j,i), 1 ) )
-                      v(k,j,i)  = MERGE( v(k,j,i), 0.0_wp,                     &
-                                         BTEST( wall_flags_0(k,j,i), 2 ) )
-                      w(k,j,i)  = MERGE( w(k,j,i), 0.0_wp,                     &
-                                         BTEST( wall_flags_0(k,j,i), 3 ) )
+                      u(k,j,i) = MERGE( u(k,j,i), 0.0_wp, BTEST( wall_flags_0(k,j,i), 1 ) )
+                      v(k,j,i) = MERGE( v(k,j,i), 0.0_wp, BTEST( wall_flags_0(k,j,i), 2 ) )
+                      w(k,j,i) = MERGE( w(k,j,i), 0.0_wp, BTEST( wall_flags_0(k,j,i), 3 ) )
 !
 !--                 TO_DO: zero setting of temperature within topography creates
@@ -3142,5 +3194,5 @@
           ENDIF
        ENDIF
-    ENDDO
+    ENDDO  ! m
 
 #endif
@@ -3156,36 +3208,10 @@
 
 #if defined( __parallel )
-    INTEGER(iwp) ::  icl         !< Parent-grid array index bound, left
-    INTEGER(iwp) ::  icr         !< Parent-grid array index bound, right
-    INTEGER(iwp) ::  jcn         !< Parent-grid array index bound, north
-    INTEGER(iwp) ::  jcs         !< Parent-grid array index bound, south
-    INTEGER(iwp) ::  icla        !< Auxiliary-array (index-mapping etc) index bound, left
-    INTEGER(iwp) ::  icra        !< Auxiliary-array (index-mapping etc) index bound, right
-    INTEGER(iwp) ::  jcna        !< Auxiliary-array (index-mapping etc) index bound, north
-    INTEGER(iwp) ::  jcsa        !< Auxiliary-array (index-mapping etc) index bound, south
-    INTEGER(iwp) ::  iclw        !< Parent-grid work array index bound, left
-    INTEGER(iwp) ::  icrw        !< Parent-grid work array index bound, right
-    INTEGER(iwp) ::  jcnw        !< Parent-grid work array index bound, north
-    INTEGER(iwp) ::  jcsw        !< Parent-grid work array index bound, south
-
-    REAL(wp), DIMENSION(1) ::  dtl         !< Time step size
+
+    REAL(wp), DIMENSION(1) ::  dtl          !< Time step size
 
 
     dtl = dt_3d
     IF ( cpl_id > 1 )  THEN
-!
-!--    Child domain boundaries in the parent indice space.
-       icl  = coarse_bound(1)
-       icr  = coarse_bound(2)
-       jcs  = coarse_bound(3)
-       jcn  = coarse_bound(4)
-       icla = coarse_bound_aux(1)
-       icra = coarse_bound_aux(2)
-       jcsa = coarse_bound_aux(3)
-       jcna = coarse_bound_aux(4)
-       iclw = coarse_bound_w(1)
-       icrw = coarse_bound_w(2)
-       jcsw = coarse_bound_w(3)
-       jcnw = coarse_bound_w(4)
 
        IF ( direction == parent_to_child )  THEN
@@ -3213,5 +3239,5 @@
     ENDIF
 
-  CONTAINS
+ CONTAINS
 
    
@@ -3223,10 +3249,10 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  ibgp       !< index running over the nbgp boundary ghost points in i-direction
-       INTEGER(iwp) ::  jbgp       !< index running over the nbgp boundary ghost points in j-direction
-       INTEGER(iwp) ::  ib         !< running index for aerosol size bins
-       INTEGER(iwp) ::  ic         !< running index for aerosol mass bins
-       INTEGER(iwp) ::  ig         !< running index for salsa gases
-       INTEGER(iwp) ::  n          !< running index for number of chemical species
+       INTEGER(iwp) ::  ibgp       !< Index running over the nbgp boundary ghost points in i-direction
+       INTEGER(iwp) ::  jbgp       !< Index running over the nbgp boundary ghost points in j-direction
+       INTEGER(iwp) ::  lb         !< Running index for aerosol size bins
+       INTEGER(iwp) ::  lc         !< Running index for aerosol mass bins
+       INTEGER(iwp) ::  lg         !< Running index for salsa gases
+       INTEGER(iwp) ::  n          !< Running index for number of chemical species
       
 !
@@ -3242,11 +3268,11 @@
              CALL pmci_interp_1sto_lr( w, wc, kctw, jflo, jfuo, kflw, kfuw, 'l', 'w' )
 
-             IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.                        &
-                  (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.                         &
-                     .NOT. constant_diffusion ) )  THEN
+             IF ( (         rans_mode_parent  .AND.         rans_mode )  .OR.                       &
+                  (  .NOT.  rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.                        &
+                     .NOT.  constant_diffusion ) )  THEN
 !                CALL pmci_interp_1sto_lr( e, ec, kcto, jflo, jfuo, kflo, kfuo, 'l', 'e' )
 !
 !--             Interpolation of e is replaced by the Neumann condition. 
-                DO ibgp = -nbgp, -1
+                DO  ibgp = -nbgp, -1
                    e(nzb:nzt,nys:nyn,ibgp) = e(nzb:nzt,nys:nyn,0)
                 ENDDO
@@ -3290,15 +3316,15 @@
 
              IF ( salsa  .AND.  nest_salsa )  THEN
-                DO  ib = 1, nbins_aerosol
-                   CALL pmci_interp_1sto_lr( aerosol_number(ib)%conc, aerosol_number_c(:,:,:,ib),    &
+                DO  lb = 1, nbins_aerosol
+                   CALL pmci_interp_1sto_lr( aerosol_number(lb)%conc, aerosol_number_c(:,:,:,lb),   &
                                              kcto, jflo, jfuo, kflo, kfuo, 'l', 's')
                 ENDDO
-                DO  ic = 1, nbins_aerosol * ncomponents_mass
-                   CALL pmci_interp_1sto_lr( aerosol_mass(ic)%conc, aerosol_mass_c(:,:,:,ic),        &
+                DO  lc = 1, nbins_aerosol * ncomponents_mass
+                   CALL pmci_interp_1sto_lr( aerosol_mass(lc)%conc, aerosol_mass_c(:,:,:,lc),       &
                                              kcto, jflo, jfuo, kflo, kfuo, 'l', 's')
                 ENDDO
                 IF ( .NOT. salsa_gases_from_chem )  THEN
-                   DO  ig = 1, ngases_salsa
-                      CALL pmci_interp_1sto_lr( salsa_gas(ig)%conc, salsa_gas_c(:,:,:,ig),         &
+                   DO  lg = 1, ngases_salsa
+                      CALL pmci_interp_1sto_lr( salsa_gas(lg)%conc, salsa_gas_c(:,:,:,lg),          &
                                                 kcto, jflo, jfuo, kflo, kfuo, 'l', 's')
                    ENDDO
@@ -3315,11 +3341,11 @@
              CALL pmci_interp_1sto_lr( w, wc, kctw, jflo, jfuo, kflw, kfuw, 'r', 'w' )
 
-             IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.                        &
-                  (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.                         &
-                     .NOT. constant_diffusion ) )  THEN
+             IF ( (         rans_mode_parent  .AND.         rans_mode )  .OR.                       &
+                  (  .NOT.  rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.                        &
+                     .NOT.  constant_diffusion ) )  THEN
 !                CALL pmci_interp_1sto_lr( e, ec, kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, 'r', 'e' )
 !
 !--             Interpolation of e is replaced by the Neumann condition. 
-                DO ibgp = nx+1, nx+nbgp
+                DO  ibgp = nx+1, nx+nbgp
                    e(nzb:nzt,nys:nyn,ibgp) = e(nzb:nzt,nys:nyn,nx)
                 ENDDO
@@ -3328,8 +3354,7 @@
              IF ( rans_mode_parent  .AND.  rans_mode  .AND.  rans_tke_e )  THEN
                 CALL pmci_interp_1sto_lr( diss, dissc, kcto, jflo, jfuo, kflo, kfuo, 'r', 's' )
-
              ENDIF
 
-             IF ( .NOT. neutral )  THEN
+             IF (  .NOT.  neutral )  THEN
                 CALL pmci_interp_1sto_lr( pt, ptc, kcto, jflo, jfuo, kflo, kfuo, 'r', 's' )
              ENDIF
@@ -3362,15 +3387,15 @@
 
              IF ( salsa  .AND.  nest_salsa )  THEN
-                DO  ib = 1, nbins_aerosol
-                   CALL pmci_interp_1sto_lr( aerosol_number(ib)%conc, aerosol_number_c(:,:,:,ib),    &
+                DO  lb = 1, nbins_aerosol
+                   CALL pmci_interp_1sto_lr( aerosol_number(lb)%conc, aerosol_number_c(:,:,:,lb),   &
                                              kcto, jflo, jfuo, kflo, kfuo, 'r', 's' )
                 ENDDO
-                DO  ic = 1, nbins_aerosol * ncomponents_mass
-                   CALL pmci_interp_1sto_lr( aerosol_mass(ic)%conc, aerosol_mass_c(:,:,:,ic),        &
+                DO  lc = 1, nbins_aerosol * ncomponents_mass
+                   CALL pmci_interp_1sto_lr( aerosol_mass(lc)%conc, aerosol_mass_c(:,:,:,lc),       &
                                              kcto, jflo, jfuo, kflo, kfuo, 'r', 's' )
                 ENDDO
                 IF ( .NOT. salsa_gases_from_chem )  THEN
-                   DO  ig = 1, ngases_salsa
-                      CALL pmci_interp_1sto_lr( salsa_gas(ig)%conc, salsa_gas_c(:,:,:,ig),         &
+                   DO  lg = 1, ngases_salsa
+                      CALL pmci_interp_1sto_lr( salsa_gas(lg)%conc, salsa_gas_c(:,:,:,lg),          &
                                                 kcto, jflo, jfuo, kflo, kfuo, 'r', 's' )
                    ENDDO
@@ -3387,11 +3412,11 @@
              CALL pmci_interp_1sto_sn( u, uc, kcto, iflu, ifuu, kflo, kfuo, 's', 'u' )
 
-             IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.   &
-                  (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.    &
-                     .NOT. constant_diffusion ) )  THEN
+             IF ( (         rans_mode_parent  .AND.         rans_mode )  .OR.                       &
+                  (  .NOT.  rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.                        &
+                     .NOT.  constant_diffusion ) )  THEN
 !                CALL pmci_interp_1sto_sn( e, ec, kcto, iflo, ifuo, kflo, kfuo, 's', 'e' )
 !
 !--             Interpolation of e is replaced by the Neumann condition. 
-                DO jbgp = -nbgp, -1
+                DO  jbgp = -nbgp, -1
                    e(nzb:nzt,jbgp,nxl:nxr) = e(nzb:nzt,0,nxl:nxr)
                 ENDDO
@@ -3402,5 +3427,5 @@
              ENDIF
 
-             IF ( .NOT. neutral )  THEN
+             IF (  .NOT.  neutral )  THEN
                 CALL pmci_interp_1sto_sn( pt, ptc, kcto, iflo, ifuo, kflo, kfuo, 's', 's' )
              ENDIF
@@ -3433,15 +3458,15 @@
              
              IF ( salsa  .AND.  nest_salsa )  THEN
-                DO  ib = 1, nbins_aerosol
-                   CALL pmci_interp_1sto_sn( aerosol_number(ib)%conc, aerosol_number_c(:,:,:,ib),    &
+                DO  lb = 1, nbins_aerosol
+                   CALL pmci_interp_1sto_sn( aerosol_number(lb)%conc, aerosol_number_c(:,:,:,lb),   &
                                              kcto, iflo, ifuo, kflo, kfuo, 's', 's' )
                 ENDDO
-                DO  ic = 1, nbins_aerosol * ncomponents_mass
-                   CALL pmci_interp_1sto_sn( aerosol_mass(ic)%conc, aerosol_mass_c(:,:,:,ic),        &
+                DO  lc = 1, nbins_aerosol * ncomponents_mass
+                   CALL pmci_interp_1sto_sn( aerosol_mass(lc)%conc, aerosol_mass_c(:,:,:,lc),       &
                                              kcto, iflo, ifuo, kflo, kfuo, 's', 's' )
                 ENDDO
                 IF ( .NOT. salsa_gases_from_chem )  THEN
-                   DO  ig = 1, ngases_salsa
-                      CALL pmci_interp_1sto_sn( salsa_gas(ig)%conc, salsa_gas_c(:,:,:,ig),         &
+                   DO  lg = 1, ngases_salsa
+                      CALL pmci_interp_1sto_sn( salsa_gas(lg)%conc, salsa_gas_c(:,:,:,lg),          &
                                                 kcto, iflo, ifuo, kflo, kfuo, 's', 's' )
                    ENDDO
@@ -3458,11 +3483,11 @@
              CALL pmci_interp_1sto_sn( u, uc, kcto, iflu, ifuu, kflo, kfuo, 'n', 'u' )
 
-             IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.                        & 
-                  (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.                         &
-                     .NOT. constant_diffusion ) )  THEN
+             IF ( (         rans_mode_parent  .AND.         rans_mode )  .OR.                       & 
+                  (  .NOT.  rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.                        &
+                     .NOT.  constant_diffusion ) )  THEN
 !                CALL pmci_interp_1sto_sn( e, ec, kcto, iflo, ifuo, kflo, kfuo, 'n', 'e' )
 !
 !--             Interpolation of e is replaced by the Neumann condition. 
-                DO jbgp = ny+1, ny+nbgp
+                DO  jbgp = ny+1, ny+nbgp
                    e(nzb:nzt,jbgp,nxl:nxr) = e(nzb:nzt,ny,nxl:nxr)
                 ENDDO
@@ -3473,5 +3498,5 @@
              ENDIF
 
-             IF ( .NOT. neutral )  THEN
+             IF (  .NOT.  neutral )  THEN
                 CALL pmci_interp_1sto_sn( pt, ptc, kcto, iflo, ifuo, kflo, kfuo, 'n', 's' )
              ENDIF
@@ -3504,15 +3529,15 @@
              
              IF ( salsa  .AND.  nest_salsa )  THEN
-                DO  ib = 1, nbins_aerosol
-                   CALL pmci_interp_1sto_sn( aerosol_number(ib)%conc, aerosol_number_c(:,:,:,ib),    &
+                DO  lb = 1, nbins_aerosol
+                   CALL pmci_interp_1sto_sn( aerosol_number(lb)%conc, aerosol_number_c(:,:,:,lb),   &
                                              kcto, iflo, ifuo, kflo, kfuo, 'n', 's' )
                 ENDDO
-                DO  ic = 1, nbins_aerosol * ncomponents_mass
-                   CALL pmci_interp_1sto_sn( aerosol_mass(ic)%conc, aerosol_mass_c(:,:,:,ic),        &
+                DO  lc = 1, nbins_aerosol * ncomponents_mass
+                   CALL pmci_interp_1sto_sn( aerosol_mass(lc)%conc, aerosol_mass_c(:,:,:,lc),       &
                                              kcto, iflo, ifuo, kflo, kfuo, 'n', 's' )
                 ENDDO
                 IF ( .NOT. salsa_gases_from_chem )  THEN
-                   DO  ig = 1, ngases_salsa
-                      CALL pmci_interp_1sto_sn( salsa_gas(ig)%conc, salsa_gas_c(:,:,:,ig),         &
+                   DO  lg = 1, ngases_salsa
+                      CALL pmci_interp_1sto_sn( salsa_gas(lg)%conc, salsa_gas_c(:,:,:,lg),          &
                                                 kcto, iflo, ifuo, kflo, kfuo, 'n', 's' )
                    ENDDO
@@ -3529,7 +3554,7 @@
        CALL pmci_interp_1sto_t( v, vc, kcto, iflo, ifuo, jflv, jfuv, 'v' )
 
-       IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.         &
-            (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.          &
-               .NOT. constant_diffusion ) )  THEN
+       IF ( (         rans_mode_parent  .AND.         rans_mode )  .OR.                             &
+            (  .NOT.  rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.                              &
+               .NOT.  constant_diffusion ) )  THEN
 !          CALL pmci_interp_1sto_t( e, ec, kcto, iflo, ifuo, jflo, jfuo, 'e' )
 !
@@ -3570,15 +3595,15 @@
        
        IF ( salsa  .AND.  nest_salsa )  THEN
-          DO  ib = 1, nbins_aerosol
-             CALL pmci_interp_1sto_t( aerosol_number(ib)%conc, aerosol_number_c(:,:,:,ib),           &
+          DO  lb = 1, nbins_aerosol
+             CALL pmci_interp_1sto_t( aerosol_number(lb)%conc, aerosol_number_c(:,:,:,lb),          &
                                       kcto, iflo, ifuo, jflo, jfuo, 's' )
           ENDDO
-          DO  ic = 1, nbins_aerosol * ncomponents_mass
-             CALL pmci_interp_1sto_t( aerosol_mass(ic)%conc, aerosol_mass_c(:,:,:,ic),               &
+          DO  lc = 1, nbins_aerosol * ncomponents_mass
+             CALL pmci_interp_1sto_t( aerosol_mass(lc)%conc, aerosol_mass_c(:,:,:,lc),              &
                                       kcto, iflo, ifuo, jflo, jfuo, 's' )
           ENDDO
           IF ( .NOT. salsa_gases_from_chem )  THEN
-             DO  ig = 1, ngases_salsa
-                CALL pmci_interp_1sto_t( salsa_gas(ig)%conc, salsa_gas_c(:,:,:,ig),                &
+             DO  lg = 1, ngases_salsa
+                CALL pmci_interp_1sto_t( salsa_gas(lg)%conc, salsa_gas_c(:,:,:,lg),                 &
                                          kcto, iflo, ifuo, jflo, jfuo, 's' )
              ENDDO
@@ -3596,10 +3621,10 @@
 !--   Note that TKE is not anterpolated.
       IMPLICIT NONE
-      INTEGER(iwp) ::  ib         !< running index for aerosol size bins
-      INTEGER(iwp) ::  ic         !< running index for aerosol mass bins
-      INTEGER(iwp) ::  n          !< running index for number of chemical species
-      INTEGER(iwp) ::  ig         !< running index for salsa gases
-
-
+      INTEGER(iwp) ::  lb         !< Running index for aerosol size bins
+      INTEGER(iwp) ::  lc         !< Running index for aerosol mass bins
+      INTEGER(iwp) ::  lg         !< Running index for salsa gases
+      INTEGER(iwp) ::  n          !< Running index for number of chemical species
+
+      
       CALL pmci_anterp_tophat( u,  uc,  kcto, iflu, ifuu, jflo, jfuo, kflo, kfuo, ijkfc_u, 'u' )
       CALL pmci_anterp_tophat( v,  vc,  kcto, iflo, ifuo, jflv, jfuv, kflo, kfuo, ijkfc_v, 'v' )
@@ -3613,6 +3638,6 @@
 !--      Anterpolation of dissipation rate only if TKE-e closure is applied.
          IF ( rans_tke_e )  THEN
-            CALL pmci_anterp_tophat( diss, dissc, kcto, iflo, ifuo, jflo, jfuo,&
-                                     kflo, kfuo, ijkfc_s, 'diss' )
+            CALL pmci_anterp_tophat( diss, dissc, kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo,         &
+                 ijkfc_s, 'diss' )
          ENDIF
 
@@ -3661,15 +3686,15 @@
       
       IF ( salsa  .AND.  nest_salsa )  THEN
-         DO  ib = 1, nbins_aerosol
-            CALL pmci_anterp_tophat( aerosol_number(ib)%conc, aerosol_number_c(:,:,:,ib),            &
+         DO  lb = 1, nbins_aerosol
+            CALL pmci_anterp_tophat( aerosol_number(lb)%conc, aerosol_number_c(:,:,:,lb),           &
                                      kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
          ENDDO
-         DO  ic = 1, nbins_aerosol * ncomponents_mass
-            CALL pmci_anterp_tophat( aerosol_mass(ic)%conc, aerosol_mass_c(:,:,:,ic),                &
+         DO  lc = 1, nbins_aerosol * ncomponents_mass
+            CALL pmci_anterp_tophat( aerosol_mass(lc)%conc, aerosol_mass_c(:,:,:,lc),               &
                                      kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
          ENDDO
          IF ( .NOT. salsa_gases_from_chem )  THEN
-            DO  ig = 1, ngases_salsa
-               CALL pmci_anterp_tophat( salsa_gas(ig)%conc, salsa_gas_c(:,:,:,ig),                 &
+            DO  lg = 1, ngases_salsa
+               CALL pmci_anterp_tophat( salsa_gas(lg)%conc, salsa_gas_c(:,:,:,lg),                  &
                                         kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
             ENDDO
@@ -3681,5 +3706,5 @@
 
 
-   SUBROUTINE pmci_interp_1sto_lr( f, fc, kct, jfl, jfu, kfl, kfu, edge, var )
+   SUBROUTINE pmci_interp_1sto_lr( child_array, parent_array, kct, jfl, jfu, kfl, kfu, edge, var )
 !
 !--   Interpolation of ghost-node values used as the child-domain boundary
@@ -3687,30 +3712,42 @@
       IMPLICIT NONE
 
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) ::  f   !< Child-grid array
-      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN)        ::  fc  !< Parent-grid array
-      INTEGER(iwp) :: kct                                     !< The parent-grid index in z-direction just below the boundary value node
-      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfl  !< Indicates start index of child cells belonging to certain parent cell - y direction
-      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu  !< Indicates end index of child cells belonging to certain parent cell - y direction
-      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfl  !< Indicates start index of child cells belonging to certain parent cell - z direction
-      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfu  !< Indicates end index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), INTENT(IN) ::  kct  !< The parent-grid index in z-direction just below the boundary value node
+      
+      INTEGER(iwp), DIMENSION(jpsa:jpna), INTENT(IN) ::  jfl  !< Indicates start index of child cells belonging to certain
+                                                              !< parent cell - y direction
+      INTEGER(iwp), DIMENSION(jpsa:jpna), INTENT(IN) ::  jfu  !< Indicates end index of child cells belonging to certain
+                                                              !< parent cell - y direction
+      INTEGER(iwp), DIMENSION(0:pg%nz+1), INTENT(IN) ::  kfl  !< Indicates start index of child cells belonging to certain
+                                                              !< parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:pg%nz+1), INTENT(IN) ::  kfu  !< Indicates end index of child cells belonging to certain
+                                                              !< parent cell - z direction
+
+      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) ::  child_array   !< Child-grid array
+      REAL(wp), DIMENSION(0:pg%nz+1,jps:jpn,ipl:ipr), INTENT(IN)        ::  parent_array  !< Parent-grid array
+
       CHARACTER(LEN=1), INTENT(IN) ::  edge                   !< Edge symbol: 'l' or 'r'
-      CHARACTER(LEN=1), INTENT(IN) ::  var                    !< Variable symbol: 'u', 'v', 'w' or 's'
+      CHARACTER(LEN=1), INTENT(IN) ::  var                    !< Variable symbol: 'u', 'v', 'w' or 's'      
 !
 !--   Local variables:
-      INTEGER(iwp) ::  ib       !< Fixed i-index pointing to the node just behind the boundary-value node
-      INTEGER(iwp) ::  ibc      !< Fixed i-index pointing to the boundary-value nodes (either i or iend)
-      INTEGER(iwp) ::  ibgp     !< Index running over the redundant boundary ghost points in i-direction
+      INTEGER(iwp) ::  icb      !< Fixed child-grid index in the x-direction pointing to the node just behind the
+                                !< boundary-value node
+      INTEGER(iwp) ::  icbc     !< Fixed child-grid index in the x-direction pointing to the boundary-value nodes
+      INTEGER(iwp) ::  icbgp    !< Index running over the redundant boundary ghost points in the x-direction
       INTEGER(iwp) ::  ierr     !< MPI error code
-      INTEGER(iwp) ::  j        !< Running index in the y-direction
-      INTEGER(iwp) ::  k        !< Running index in the z-direction
-      INTEGER(iwp) ::  lbeg     !< l-index pointing to the starting point of workarrc_lr in the l-direction 
-      INTEGER(iwp) ::  lw       !< Reduced l-index for workarrc_lr pointing to the boundary ghost node
-      INTEGER(iwp) ::  lwp      !< Reduced l-index for workarrc_lr pointing to the first prognostic node
-      INTEGER(iwp) ::  m        !< Parent-grid running index in the y-direction
-      INTEGER(iwp) ::  n        !< Parent-grid running index in the z-direction
+      INTEGER(iwp) ::  ipbeg    !< Parent-grid index in the x-direction pointing to the starting point of workarr_lr
+                                !< in the parent-grid array
+      INTEGER(iwp) ::  ipw      !< Reduced parent-grid index in the x-direction for workarr_lr pointing to
+                                !< the boundary ghost node
+      INTEGER(iwp) ::  ipwp     !< Reduced parent-grid index in the x-direction for workarr_lr pointing to
+                                !< the first prognostic node
+      INTEGER(iwp) ::  jc       !< Running child-grid index in the y-direction
+      INTEGER(iwp) ::  jp       !< Running parent-grid index in the y-direction
+      INTEGER(iwp) ::  kc       !< Running child-grid index in the z-direction
+      INTEGER(iwp) ::  kp       !< Running parent-grid index in the z-direction      
+      
       REAL(wp) ::  cb           !< Interpolation coefficient for the boundary ghost node  
       REAL(wp) ::  cp           !< Interpolation coefficient for the first prognostic node
-      REAL(wp) ::  f_interp_1   !< Value interpolated in x direction from the parent-grid data
-      REAL(wp) ::  f_interp_2   !< Auxiliary value interpolated in x direction from the parent-grid data
+      REAL(wp) ::  c_interp_1   !< Value interpolated to the flux point in x direction from the parent-grid data
+      REAL(wp) ::  c_interp_2   !< Auxiliary value interpolated  to the flux point in x direction from the parent-grid data
 
 ! 
@@ -3720,55 +3757,53 @@
 !--      For u, nxl is a ghost node, but not for the other variables
          IF ( var == 'u' )  THEN
-            ibc   = nxl    
-            ib    = ibc - 1
-            lw    = 2
-            lwp   = lw        ! This is redundant when var == 'u' 
-            lbeg  = icl
+            icbc  = nxl    
+            icb   = icbc - 1
+            ipw   = 2
+            ipwp  = ipw        ! This is redundant when var == 'u' 
+            ipbeg = ipl
          ELSE
-            ibc   = nxl - 1
-            ib    = ibc - 1
-            lw    = 1
-            lwp   = 2
-            lbeg  = icl
+            icbc  = nxl - 1
+            icb   = icbc - 1
+            ipw   = 1
+            ipwp  = 2
+            ipbeg = ipl
          ENDIF        
       ELSEIF ( edge == 'r' )  THEN
          IF ( var == 'u' )  THEN
-            ibc   = nxr + 1 
-            ib    = ibc + 1
-            lw    = 1
-            lwp   = lw        ! This is redundant when var == 'u'            
-            lbeg  = icr - 2
+            icbc  = nxr + 1 
+            icb   = icbc + 1
+            ipw   = 1
+            ipwp  = ipw        ! This is redundant when var == 'u'            
+            ipbeg = ipr - 2
          ELSE
-            ibc   = nxr + 1
-            ib    = ibc + 1
-            lw    = 1
-            lwp   = 0
-            lbeg  = icr - 2
+            icbc  = nxr + 1
+            icb   = icbc + 1
+            ipw   = 1
+            ipwp  = 0
+            ipbeg = ipr - 2
          ENDIF         
       ENDIF
 !
 !--   Interpolation coefficients
-      IF  ( interpolation_scheme_lrsn == 1 )  THEN
+      IF ( interpolation_scheme_lrsn == 1 )  THEN
          cb = 1.0_wp  ! 1st-order upwind 
-      ELSE IF  ( interpolation_scheme_lrsn == 2 )  THEN
+      ELSE IF ( interpolation_scheme_lrsn == 2 )  THEN
          cb = 0.5_wp  ! 2nd-order central
       ELSE
          cb = 0.5_wp  ! 2nd-order central (default)
       ENDIF         
-      cp    = 1.0_wp - cb
-!
-!--   Substitute the necessary parent-grid data to the work array workarrc_lr. 
-      workarrc_lr = 0.0_wp     
-      IF  ( pdims(2) > 1 )  THEN
+      cp = 1.0_wp - cb
+!
+!--   Substitute the necessary parent-grid data to the work array workarr_lr. 
+      workarr_lr = 0.0_wp     
+      IF ( pdims(2) > 1 )  THEN
 #if defined( __parallel )
-         IF  ( bc_dirichlet_s )  THEN 
-            workarrc_lr(0:cg%nz+1,jcsw:jcnw-1,0:2)                              &
-                 = fc(0:cg%nz+1,jcsw:jcnw-1,lbeg:lbeg+2)
-         ELSE IF  ( bc_dirichlet_n )  THEN
-            workarrc_lr(0:cg%nz+1,jcsw+1:jcnw,0:2)                              &
-                 = fc(0:cg%nz+1,jcsw+1:jcnw,lbeg:lbeg+2)
+         IF ( bc_dirichlet_s )  THEN 
+            workarr_lr(0:pg%nz+1,jpsw:jpnw-1,0:2) = parent_array(0:pg%nz+1,jpsw:jpnw-1,ipbeg:ipbeg+2)
+         ELSE IF ( bc_dirichlet_n )  THEN
+            workarr_lr(0:pg%nz+1,jpsw+1:jpnw,0:2) = parent_array(0:pg%nz+1,jpsw+1:jpnw,ipbeg:ipbeg+2)
          ELSE
-            workarrc_lr(0:cg%nz+1,jcsw+1:jcnw-1,0:2)                            &
-                 = fc(0:cg%nz+1,jcsw+1:jcnw-1,lbeg:lbeg+2)
+            workarr_lr(0:pg%nz+1,jpsw+1:jpnw-1,0:2)                                                 &
+                 = parent_array(0:pg%nz+1,jpsw+1:jpnw-1,ipbeg:ipbeg+2)
          ENDIF
 !
